You can not select more than 25 topics Topics must start with a letter or number, can include dashes ('-') and can be up to 35 characters long.

bashrc 19 KiB

13 years ago
13 years ago
13 years ago
12 years ago
13 years ago
13 years ago
12 years ago
13 years ago
12 years ago
12 years ago
13 years ago
13 years ago
13 years ago
13 years ago
12 years ago
12 years ago
13 years ago
12 years ago
13 years ago
12 years ago
13 years ago
12 years ago
13 years ago
13 years ago
13 years ago
13 years ago
13 years ago
12 years ago
13 years ago
13 years ago
13 years ago
13 years ago
12 years ago
12 years ago
13 years ago
13 years ago
13 years ago
12 years ago
13 years ago
13 years ago
12 years ago
12 years ago
13 years ago
12 years ago
13 years ago
12 years ago
12 years ago
12 years ago
12 years ago
12 years ago
12 years ago
12 years ago
12 years ago
12 years ago
12 years ago
12 years ago
13 years ago
12 years ago
12 years ago
13 years ago
12 years ago
12 years ago
13 years ago
13 years ago
13 years ago
12 years ago
13 years ago
13 years ago
13 years ago
12 years ago
12 years ago
12 years ago
12 years ago
12 years ago
12 years ago
12 years ago
12 years ago
12 years ago
12 years ago
12 years ago
12 years ago
12 years ago
12 years ago
12 years ago
12 years ago
12 years ago
12 years ago
12 years ago
12 years ago
12 years ago
12 years ago
12 years ago
12 years ago
12 years ago
12 years ago
12 years ago
12 years ago
12 years ago
12 years ago
12 years ago
13 years ago
13 years ago
13 years ago
13 years ago
12 years ago
12 years ago
13 years ago
13 years ago
13 years ago
13 years ago
13 years ago
13 years ago
12 years ago
12 years ago
12 years ago
13 years ago
13 years ago
13 years ago
13 years ago
12 years ago
12 years ago
12 years ago
12 years ago
12 years ago
12 years ago
12 years ago
12 years ago
13 years ago
12 years ago
13 years ago
12 years ago
13 years ago
13 years ago
13 years ago
13 years ago
13 years ago
12 years ago
13 years ago
13 years ago
13 years ago
13 years ago
13 years ago
13 years ago
13 years ago
13 years ago
13 years ago
13 years ago
13 years ago
13 years ago
13 years ago
12 years ago
13 years ago
12 years ago
12 years ago
12 years ago
12 years ago
12 years ago
12 years ago
13 years ago
12 years ago
13 years ago
13 years ago
12 years ago
12 years ago
12 years ago
12 years ago
12 years ago
12 years ago
13 years ago
13 years ago
13 years ago
13 years ago
13 years ago
13 years ago
13 years ago
12 years ago
123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109110111112113114115116117118119120121122123124125126127128129130131132133134135136137138139140141142143144145146147148149150151152153154155156157158159160161162163164165166167168169170171172173174175176177178179180181182183184185186187188189190191192193194195196197198199200201202203204205206207208209210211212213214215216217218219220221222223224225226227228229230231232233234235236237238239240241242243244245246247248249250251252253254255256257258259260261262263264265266267268269270271272273274275276277278279280281282283284285286287288289290291292293294295296297298299300301302303304305306307308309310311312313314315316317318319320321322323324325326327328329330331332333334335336337338339340341342343344345346347348349350351352353354355356357358359360361362363364365366367368369370371372373374375376377378379380381382383384385386387388389390391392393394395396397398399400401402403404405406407408409410411412413414415416417418419420421422423424425426427428429430431432433434435436437438439440441442443444445446447448449450451452453454455456457458459460461462463464465466467468469470471472473474475476477478479480481482483484485486487488489490491492493494495496497498499500501502503504505506507508509510511512513514515516517518519520521522523524525526527528529530531532533534535536537538539540541542543544545546547548549550551552553554555556557558559560561562563564565566567568569570571572573574575576577578579580581582583584585586587588589590591592593594595596597598599600601602603604605606607608609610611612613614615616617618619620621622623624625626627628629630631632633634635636637638639640641642643644645646647648649650651652653654655656657658659660661662663664665666667668669670671672673674675676677678679680681682683684685686687688689690691692693694695696697698699700701702703704705706707708709710711712713714715716717718719720721722723724725726727728729730731732733734735736737738739740741742743744745746747748749750751752753754755756757758759760761762763764765766767768769770771772
  1. #!/bin/bash
  2. # If not running interactively, don't do anything
  3. [[ $- != *i* ]] && return
  4. ##########################################
  5. null(){
  6. "$@" >/dev/null 2>&1
  7. }
  8. __try_exec(){
  9. type $1 >/dev/null 2>&1 && "$@"
  10. }
  11. ##########################
  12. # system type
  13. alias ismsys=false
  14. alias iscygwin=false
  15. alias iswindows=false
  16. alias isdarwin=false
  17. alias islinux=false
  18. alias with_coreutils=false # for mac
  19. case `uname` in
  20. (MINGW*) alias ismsys=true ;;
  21. (CYGWIN*) alias iscygwin=true ;;
  22. (Darwin*) alias isdarwin=true ;;
  23. (Linux*) alias islinux=true ;;
  24. esac
  25. null ls --version && alias with_coreutils=true
  26. ( ismsys || iscygwin ) && alias iswindows=true
  27. #################################
  28. if false iswindows
  29. then
  30. export PAGER='tr -d \\r | less'
  31. else
  32. export PAGER="less"
  33. fi
  34. export LESS="-iRMX"
  35. if null type vim
  36. then
  37. export EDITOR=vim
  38. else
  39. export EDITOR=vi
  40. fi
  41. export LANG=ja_JP.UTF-8
  42. export LC_MESSAGES=C
  43. # export CDPATH=".:~"
  44. export VISUAL="$EDITOR"
  45. export GIT_PAGER="less -F"
  46. export GIT_EDITOR="$EDITOR"
  47. if test -n "$TMUX" && \
  48. echo $TERM | grep screen >/dev/null 2>&1 && \
  49. tmux display -p '#{client_termname}' | grep 256color >/dev/null 2>&1
  50. then
  51. TERM=screen-256color
  52. fi
  53. test -z "$TMP" && export TMP=/tmp/${USER}-tmp
  54. mkdir -p "$TMP"
  55. ! iswindows && null type stty && {
  56. stty stop undef # unbind C-s to stop displaying output
  57. # stty erase '^h'
  58. }
  59. if iswindows; then
  60. # export PS1=" \[\e[32m\]\u@\H \[\e[33m\]\w\[\e[0m\] \d \t\n\s \# \j \$ "
  61. # export PS1=" [\[\e[33m\]\w\[\e[0m\]]\n\[\e[32m\]\u@\H\[\e[0m\] \d \t \s.\v\nhist:\# jobs:\j \$ "
  62. export USER=$USERNAME
  63. fi
  64. _tmux_prefs(){
  65. null type tmux || return 1
  66. tmux set -g mode-keys vi
  67. }
  68. #######################
  69. iswindows && alias tty="echo cmd.exe"
  70. type fortune >/dev/null 2>&1 && {
  71. fortune
  72. echo
  73. fortune -o
  74. echo
  75. }
  76. uname -a
  77. echo TERM $TERM $(tput colors) colors connected to $(tty), \
  78. running $BASH $BASH_VERSION
  79. if test -n "$TMUX"
  80. then
  81. tmux display -p 'Using tmux #S:#I:#W.#P, client is #{client_termname}' \
  82. 2>/dev/null
  83. echo
  84. fi
  85. ###################################
  86. # some aliases and functions
  87. ( ! with_coreutils && isdarwin ) || test "$TERM" == dumb || \
  88. _coloroption=" --color=auto"
  89. ( ! with_coreutils && isdarwin ) || iswindows || \
  90. _timeoption=" --time-style=long-iso"
  91. ( ! with_coreutils && isdarwin ) || _hideoption=" --hide=[A-Z]*" # do not use
  92. _timeformat_iso="%Y-%m-%dT%H:%M:%S%z"
  93. _timeformat_rfc2822="%a, %d %b %Y %T %z"
  94. alias ls="ls -hCF${_coloroption}${_timeoption}"
  95. # export GREP_OPTIONS=""
  96. alias gr="grep -n --color=always"
  97. iswindows && alias grep="grep -n"
  98. # alias ll="ls -l"
  99. # alias la="ls -A"
  100. # alias lla="ls -Al"
  101. alias less="less -F"
  102. alias em="emacs -nw"
  103. null type vim && alias vi=vim
  104. alias pstree="LANG=C pstree"
  105. alias cp="cp -v"
  106. alias mv="mv -v"
  107. alias rm="rm -v"
  108. alias psaux="ps auxww"
  109. alias q=exit
  110. alias e3=e3em
  111. #alias dirs="dirs -v -l | \grep -v \$(printf '%s$' \$PWD)"
  112. alias po=popd
  113. alias pu=pushd
  114. alias sudo="sudo " # use aliases through sudo
  115. alias sudoe="sudoedit"
  116. alias halt="sudo halt"
  117. alias reboot="sudo reboot"
  118. alias suspend="dbus-send --system --print-reply --dest=org.freedesktop.UPower \
  119. /org/freedesktop/UPower org.freedesktop.UPower.Suspend"
  120. alias hibernate="dbus-send --system --print-reply --dest=org.freedesktop.UPower \
  121. /org/freedesktop/UPower org.freedesktop.UPower.Hibernate"
  122. alias rand="echo \$RANDOM"
  123. alias xunp="file-roller -h"
  124. alias pc="sudo \paco -D"
  125. alias pycalc="python -i -c 'from math import *' "
  126. alias py3=python3
  127. alias py2=python2
  128. alias _reloadrc="test -f ~/.bashrc && source ~/.bashrc"
  129. # alias mytime="date +%Y%m%d-%H%M%S"
  130. alias sh="ENV=$HOME/.shrc PS1=\$\ PROMPT_COMMAND="" sh"
  131. # type trash >/dev/null 2>&1 && alias rm=trash
  132. alias mpg123="mpg123 -C -v --title"
  133. alias xm="xmms2"
  134. #export PLAYER="mpg123 -C -v --title"
  135. null type screen && alias screen="screen -e^z^z"
  136. alias zcd="cd \`zenity --file-selection --directory\`"
  137. null type gtags && alias gtags="gtags --verbose"
  138. null type htags && alias htags="htags --xhtml --symbol --line-number \
  139. --frame --alphabet --verbose"
  140. null type aunpack && alias aunp=aunpack
  141. alias pad=notepad
  142. null type gedit && alias pad=gedit
  143. null type leafpad && alias pad=leafpad
  144. isdarwin && alias pad="open -e"
  145. alias wic=wicd-curses
  146. alias wil="wicd-cli -y -l | head"
  147. #alias wicn="wicd-cli -y -c -n"
  148. wicn(){
  149. if test $# -eq 0
  150. then
  151. local num
  152. wicd-cli -y -l | head
  153. echo -n "input num: "
  154. read num
  155. test -n "$num" && wicd-cli -y -c -n $num
  156. else
  157. wicd-cli -y -c -n $1
  158. fi
  159. }
  160. alias aptin="apt-get install"
  161. alias aptsearch="apt-cache search"
  162. alias aptshow="apt-cache show"
  163. for f in /usr/share/vim/vimcurrent/macros/less.sh \
  164. /usr/share/vim/vim73/macros/less.sh \
  165. /usr/share/vim/vim72/macros/less.sh
  166. do
  167. test -f $f && alias vl=$f && break
  168. done
  169. alias yt=yaourt
  170. null type pacman-color && {
  171. alias pacman=pacman-color
  172. export pacman_program=pacman-color # used by pacmatic
  173. export PACMAN=pacman-color # used by yaourt
  174. }
  175. null type pacmatic && {
  176. alias pacman="pacmatic"
  177. export PACMAN="pacmatic"
  178. }
  179. null type apt-get && \
  180. alias aupgrade="sudo apt-get autoremove --yes && \
  181. sudo apt-get update --yes && sudo apt-get upgrade --yes"
  182. null type port && \
  183. alias port="port -v"
  184. alias pupgrade="sudo port -v selfupdate && \
  185. { sudo port -v upgrade outdated; }"
  186. if iscygwin; then
  187. null type windate || \
  188. alias windate="/c/Windows/System32/cmd.exe //c 'echo %DATE%-%TIME%'"
  189. alias cygsu="cygstart /cygwinsetup.exe"
  190. alias emacs="CYGWIN=tty emacs -nw"
  191. alias ls="ls -CFG $(iswindows || test "$TERM" = dumb || echo --color=auto)"
  192. fi
  193. g(){
  194. if test $# -eq 0 && null type git-info
  195. then
  196. git info
  197. else
  198. git "$@"
  199. fi
  200. }
  201. if null type _git
  202. then
  203. # enable programmable completion for g
  204. complete -o bashdefault -o default -o nospace -F _git g 2>/dev/null \
  205. || complete -o default -o nospace -F _git g
  206. fi
  207. alias setup.py="sudo python3 setup.py install --record files.txt"
  208. man() {
  209. env \
  210. LESS_TERMCAP_mb=$(printf "\e[1;35m") \
  211. LESS_TERMCAP_md=$(printf "\e[1;31m") \
  212. LESS_TERMCAP_me=$(printf "\e[0m") \
  213. LESS_TERMCAP_se=$(printf "\e[0m") \
  214. LESS_TERMCAP_so=$(printf "\e[1;44;33m") \
  215. LESS_TERMCAP_ue=$(printf "\e[0m") \
  216. LESS_TERMCAP_us=$(printf "\e[1;32m") \
  217. man "$@"
  218. }
  219. scr(){
  220. _tformat="%Y%m%d-%H%M%S%z"
  221. _file=`date +${_tformat}`.script
  222. SCRIPT=${_file} script ${_file} "$@"
  223. }
  224. netwait(){
  225. while ! ping -c 1 -t 1 example.com
  226. do
  227. true
  228. done
  229. echo network works.
  230. }
  231. cd(){
  232. if test $# -eq 0
  233. then
  234. pushd ~/ >/dev/null
  235. elif test $1 = -
  236. then
  237. local pwd="$PWD"
  238. command cd $OLDPWD
  239. pushd -n "$pwd" >/dev/null # stack last dir
  240. elif ! test -d "$1"
  241. then
  242. echo `basename ${SHELL}`: cd: "$1": No such file or directory 1>&2
  243. return 1
  244. else
  245. pushd "$1" >/dev/null
  246. fi
  247. __dirs_rm_dup "$PWD"
  248. echo "$PWD"
  249. }
  250. __dirs_rm_dup(){
  251. for d in "$@"
  252. do
  253. local next="$(__realpath --strip "$d")"
  254. for l in $(\dirs -v -l | cut -d $'\n' -f 2- | \
  255. \grep -x " *[0-9]\+ \+${next}" | \grep -o "^ *[0-9]\+ " | tac)
  256. do
  257. popd +$l -n >/dev/null
  258. done
  259. done
  260. }
  261. __realpath(){
  262. if type realpath >/dev/null 2>&1
  263. then
  264. command realpath "$@"
  265. else
  266. while ! test -d $1
  267. do
  268. shift
  269. done
  270. local d="$OLDPWD"
  271. command cd "$1"
  272. echo "$PWD"
  273. command cd "$d"
  274. fi
  275. }
  276. dh(){
  277. if test $# -eq 0
  278. then
  279. dirs -v -l
  280. else
  281. local dir="$(dirs -v -l | \grep "^ *$1 \+" | sed "s/^ *[0-9]* *//g")"
  282. cd "$dir"
  283. fi
  284. }
  285. input(){
  286. local foo
  287. stty -echo
  288. read foo
  289. stty echo
  290. echo $foo
  291. }
  292. tmux(){
  293. if test $# -eq 0
  294. then
  295. (cd ~; command tmux start;)
  296. if command tmux has -t main
  297. then
  298. command tmux attach -t main
  299. else
  300. (cd ~; command tmux new -s main;)
  301. fi
  302. else
  303. command tmux "$@"
  304. fi
  305. }
  306. mcrypt-stream(){
  307. test $# -eq 2 || return 1
  308. case $1 in
  309. en)
  310. mcrypt --key $2 | base64 ;;
  311. de)
  312. base64 -d | mcrypt -d --key $2 ;;
  313. esac
  314. }
  315. gpg-stream(){
  316. test $# -eq 2 || return 1
  317. case $1 in
  318. en)
  319. gpg --passphrase $2 -c --batch |base64 ;;
  320. de)
  321. base64 -d|gpg --passphrase $2 -d --batch ;;
  322. esac
  323. }
  324. dgpg(){
  325. if test "$1" = help || test -z "$2"
  326. then
  327. echo "dgpg: dgpg <en|de> <src-suffix> [<dst-suffix>]" 1>&2
  328. return
  329. fi
  330. local srcs="$2"
  331. local dsts="$3"
  332. test -z "$dsts" && dsts="${srcs}.out"
  333. local pw
  334. echo -n "dgpg pw: "
  335. read -s pw
  336. echo ""
  337. test -z "$pw" && return 1
  338. for f in *${srcs}
  339. do
  340. local d="$(basename "$f" "${srcs}")${dsts}"
  341. echo -n "Processing $f to $d..."
  342. if test -d "$f"
  343. then
  344. echo "`printf 'failed (%s is directory)' $f`"
  345. elif test -f "$d"
  346. then
  347. echo "`printf 'failed (%s is already exists)' $d`"
  348. elif <"$f" gpg-stream $1 $pw >"$d" 2>/dev/null
  349. then
  350. echo "done"
  351. else
  352. echo "failed"
  353. test -f "$d" && rm "$d"
  354. fi
  355. done
  356. }
  357. alias enst="gpg-stream en"
  358. alias dest="gpg-stream de"
  359. showinfo(){
  360. echo "Japanese letters are 表示可能"
  361. __try_exec diskinfo
  362. ! isdarwin && test -n "${DISPLAY}" && {
  363. __try_exec xrandr | \grep --color=never ^Screen
  364. }
  365. iswindows || __try_exec finger $USER
  366. LANG=C __try_exec id
  367. __try_exec xset q
  368. }
  369. x(){
  370. if [[ -z $DISPLAY ]] && ! [[ -e /tmp/.X11-unix/X0 ]] && (( EUID )); then
  371. #mkdir -p ~/.my/log
  372. # nohup startx >~/.my/log/xorg.log 2>&1 &
  373. # exit
  374. exec startx
  375. else
  376. echo "X cant be started! Another X is already running?" 1>&2
  377. fi
  378. }
  379. bak(){
  380. for file in "$@"
  381. do
  382. cp -v ${file} ${file}.bak
  383. done
  384. }
  385. di(){
  386. if type colordiff >/dev/null 2>&1 && test $TERM != dumb
  387. then
  388. local diffcmd=colordiff
  389. else
  390. local diffcmd=diff
  391. fi
  392. ${diffcmd} -u "$@" | ${PAGER}
  393. }
  394. tb(){
  395. local tb="$HOME/.my/tb"
  396. mkdir -p "$tb"
  397. for file in "$@"
  398. do
  399. mv -t "$tb" "$file"
  400. done
  401. }
  402. mkcd(){
  403. mkdir -p $1
  404. cd $1
  405. }
  406. if test -n "$TMUX" && null type reattach-to-user-namespace
  407. then
  408. alias pbpaste="reattach-to-user-namespace pbpaste"
  409. alias pbcopy="reattach-to-user-namespace pbcopy"
  410. fi
  411. catclip(){
  412. if iswindows
  413. then
  414. cat /dev/clipboard | tr -d \\r
  415. elif isdarwin
  416. then
  417. pbpaste
  418. else
  419. xclip -o -selection "clipboard"
  420. fi
  421. }
  422. setclip(){
  423. if test $# -eq 0
  424. then
  425. exec 3<&0
  426. else
  427. exec 3<<__EOF__
  428. `cat "$@"`
  429. __EOF__
  430. fi
  431. if iswindows
  432. then
  433. 0<&3 sed -e 's/$/\r/' | tee /dev/clipboard
  434. elif isdarwin
  435. then
  436. pbcopy 0<&3
  437. else
  438. 0<&3 xclip -i -f -selection "primary" | \
  439. xclip -i -f -selection "clipboard"
  440. fi
  441. exec 3<&-
  442. }
  443. open_file(){
  444. if iswindows
  445. then
  446. cmd.exe //c start "" "$@"
  447. elif isdarwin
  448. then
  449. touch "$@"
  450. open "$@"
  451. elif islinux
  452. then
  453. touch "$@"
  454. if null type pcmanfm; then
  455. LC_MESSAGES= pcmanfm "$@"
  456. else
  457. LC_MESSAGES= xdg-open "$@" &
  458. fi
  459. else
  460. cat "$@"
  461. fi
  462. }
  463. o(){
  464. if test $# -eq 0
  465. then
  466. open_file .
  467. else
  468. for f in "$@"
  469. do
  470. open_file "$(realpath "$f")"
  471. done
  472. fi
  473. }
  474. convmv-sjis2utf8-test(){
  475. convmv -r -f sjis -t utf8 *
  476. }
  477. convmv-sjis2utf8-notest(){
  478. convmv -r -f sjis -t utf8 * --notest
  479. }
  480. #Change ANSI Colors
  481. _chengecolors(){
  482. echo -e \
  483. "\e]P0000000" \
  484. "\e]P1cd0000" \
  485. "\e]P200cd00" \
  486. "\e]P3cdcd00" \
  487. "\e]P41e90ff" \
  488. "\e]P5cd00cd" \
  489. "\e]P600cdcd" \
  490. "\e]P7353535" \
  491. "\e]P8666666" \
  492. "\e]P9ff9999" \
  493. "\e]Pa99ff99" \
  494. "\e]Pbffff99" \
  495. "\e]Pc9999ff" \
  496. "\e]Pdff99ff" \
  497. "\e]Pe99ffff" \
  498. "\e]Pfffffff"
  499. }
  500. # printf "\e]P7353535" \
  501. _colors(){
  502. echo -e \
  503. "\e[30mBlack" \
  504. "\e[31mRed" \
  505. "\e[32mGreen" \
  506. "\e[33mYellow" \
  507. "\e[34mBlue" \
  508. "\e[35mMagenta" \
  509. "\e[36mCyan" \
  510. "\e[37mWhite"
  511. echo -e \
  512. "\e[30;1mBright Black" \
  513. "\e[31;1mBright Red" \
  514. "\e[32;1mBright Green" \
  515. "\e[33;1mBright Yellow" \
  516. "\e[34;1mBright Blue" \
  517. "\e[35;1mBright Magenta" \
  518. "\e[36;1mBright Cyan" \
  519. "\e[37;1mBright White\n" \
  520. "\e[0m"
  521. }
  522. winln(){
  523. # for windose make link (actually junction)
  524. if test $# -eq 0
  525. then
  526. {
  527. echo "usage: winln TARGET LINK_NAME"
  528. echo "Create a link to TARGET with the name LINK_NAME \
  529. (that is, TARGET must already exist)."
  530. echo "About other features run 'junction'."
  531. } 1>&2
  532. return 1
  533. else
  534. junction "$2" "$1"
  535. fi
  536. }
  537. __my_moc_state(){
  538. type mocp >/dev/null 2>&1 || return
  539. test "`mocp -Q %state 2>/dev/null`" == PLAY || return
  540. printf "$1" "`mocp -Q %title 2>/dev/null`"
  541. }
  542. __my_parse_svn_branch() {
  543. local LANG=C
  544. local svn_url=$(svn info 2>/dev/null | sed -ne 's#^URL: ##p')
  545. local svn_repository_root=$(svn info 2>/dev/null | \
  546. sed -ne 's#^Repository Root: ##p')
  547. echo ${svn_url} | sed -e 's#^'"${svn_repository_root}"'##g' | \
  548. awk '{print $1}'
  549. }
  550. __my_svn_ps1(){
  551. if svn status >/dev/null 2>&1
  552. then
  553. local svn_branch=$(__my_parse_svn_branch)
  554. test -n "${svn_branch}" && printf "$1" "{$svn_branch}"
  555. fi
  556. }
  557. __my_battery_status(){
  558. local dir=/sys/class/power_supply/BAT0
  559. if test -d $dir && test -r $dir/status && test -r $dir/charge_full && \
  560. test -r $dir/charge_now
  561. then
  562. local st=$(cat $dir/status)
  563. local full=$(cat $dir/charge_full)
  564. local now=$(cat $dir/charge_now)
  565. local rate=$(expr $now \* 100 / $full)
  566. printf "$1" "${st}:${rate}%"
  567. fi
  568. }
  569. alias bat='__my_battery_status %s\\n'
  570. ip-address(){
  571. type ip >/dev/null 2>&1 || return 1
  572. local ip=$(LANG=C ip addr show scope global | \
  573. \grep --color=never --only-matching 'inet [^ ]*' | cut -d " " -f 2)
  574. test -n "$ip" && printf $1 $ip
  575. }
  576. __my_ps1_script(){
  577. local last=$?
  578. test -n "$SCRIPT" && echo "${__my_c5}SCR${__my_cdef} "
  579. return $last
  580. }
  581. __my_ps1_scale(){
  582. local last=$?
  583. echo "[LC:${LINES}x${COLUMNS}]"
  584. return $last
  585. }
  586. __my_ps1_tmux(){
  587. local last=$?
  588. null type tmux || return $last
  589. local tmuxc="$(tmux display -p '#S:#I:#W.#P' 2>/dev/null)"
  590. test -n "$TMUX" && echo "[TMUX:$tmuxc]"
  591. return $last
  592. }
  593. __my_ps1_moc(){
  594. local last=$?
  595. __my_moc_state "[MOC:%s]"
  596. return $last
  597. }
  598. for f in /usr/share/git/git-prompt.sh \
  599. /opt/local/share/doc/git-core/contrib/completion/git-prompt.sh
  600. do
  601. test -r $f && . $f && break
  602. done
  603. GIT_PS1_SHOWDIRTYSTATE=t
  604. GIT_PS1_SHOWUPSTREAM=t
  605. __my_ps1_git(){
  606. local last=$?
  607. null type __git_ps1 || return $last
  608. null __gitdir || return $last
  609. __git_ps1 "[GIT:$(__try_exec git config --get user.name):%s]"
  610. return $last
  611. }
  612. __my_ps1_ipaddr(){
  613. local last=$?
  614. ! iswindows && ip-address [Addr:%s]
  615. return $last
  616. }
  617. __my_ps1_bttry(){
  618. local last=$?
  619. local bst="${TMP}/batterystatus"
  620. if test -z "$DISPLAY" && ! iswindows
  621. then
  622. test -f $bst && local bstr="$(cat $bst)"
  623. test -n "$bstr" && ! echo $bstr | grep 100 >/dev/null 2>&1 && \
  624. echo "[Battery:$bstr]"
  625. __my_battery_status %s >$bst &
  626. fi
  627. return $last
  628. }
  629. __my_ps1_dirs(){
  630. dirs | wc -l
  631. }
  632. __my_ps1_jobs(){
  633. jobs | wc -l
  634. }
  635. if test "$TERM" != dumb
  636. then
  637. __my_c1="\[\e[1;31m\]" # color for PWD
  638. __my_c2="\[\e[0;36m\]" # color for user
  639. __my_c3="\[\e[1;30m\]" # color for OLDPWD
  640. if test "`hostname`" = arch-aspireone; then __my_c4="\[\e[1;34m\]"
  641. elif test "`hostname`" = darwin-mba.local; then __my_c4="\[\e[1;33m\]"
  642. elif test "`hostname`" = newkiwi; then __my_c4="\[\e[1;35m\]"
  643. else __my_c4="\[\e[1;32m\]" # color for ::
  644. fi
  645. __my_c5="\[\e[30;47m\]" # color for SCR
  646. __my_cdef="\[\e[0m\]"
  647. fi
  648. _PS1="\
  649. ${__my_c4}:: ${__my_cdef}[${__my_c2}\u@\H${__my_cdef}:${__my_c1}\w/${__my_cdef}]\$(__my_ps1_scale)\$(__my_ps1_git)\$(__my_ps1_bttry)\$(__my_ps1_ipaddr)\$(__my_ps1_moc)\n\
  650. ${__my_c4}:: ${__my_cdef}l${SHLVL}n\#j\js\$? \D{%T} $(__my_ps1_script)\$ "
  651. PS1=$_PS1
  652. __my_set_title(){
  653. title="$(echo $@)"
  654. case $TERM in
  655. (rxvt*|xterm*|aterm|screen*)
  656. test -t 1 &&
  657. test -n "$DISPLAY" &&
  658. test -z "$EMACS" &&
  659. echo -n -e "\033]0;${title}\007"
  660. ;;
  661. esac
  662. }
  663. PROMPT_COMMAND="__my_set_title \${USER}@\${HOSTNAME}\ \${PWD}"
  664. # copied from https://wiki.archlinux.org/index.php/X_resources
  665. invader(){
  666. # ANSI color scheme script featuring Space Invaders
  667. #
  668. # Original: http://crunchbanglinux.org/forums/post/126921/#p126921
  669. # Modified by lolilolicon
  670. #
  671. f=3 b=4
  672. for j in f b; do
  673. for i in {0..7}; do
  674. printf -v $j$i %b "\e[${!j}${i}m"
  675. done
  676. done
  677. bld=$'\e[1m'
  678. rst=$'\e[0m'
  679. cat << EOF
  680. $f1 ▀▄ ▄▀ $f2 ▄▄▄████▄▄▄ $f3 ▄██▄ $f4 ▀▄ ▄▀ $f5 ▄▄▄████▄▄▄ $f6 ▄██▄ $rst
  681. $f1 ▄█▀███▀█▄ $f2███▀▀██▀▀███ $f3▄█▀██▀█▄ $f4 ▄█▀███▀█▄ $f5███▀▀██▀▀███ $f6▄█▀██▀█▄$rst
  682. $f1█▀███████▀█ $f2▀▀███▀▀███▀▀ $f3▀█▀██▀█▀ $f4█▀███████▀█ $f5▀▀███▀▀███▀▀ $f6▀█▀██▀█▀$rst
  683. $f1▀ ▀▄▄ ▄▄▀ ▀ $f2 ▀█▄ ▀▀ ▄█▀ $f3▀▄ ▄▀ $f4▀ ▀▄▄ ▄▄▀ ▀ $f5 ▀█▄ ▀▀ ▄█▀ $f6▀▄ ▄▀$rst
  684. $bld$f1▄ ▀▄ ▄▀ ▄ $f2 ▄▄▄████▄▄▄ $f3 ▄██▄ $f4▄ ▀▄ ▄▀ ▄ $f5 ▄▄▄████▄▄▄ $f6 ▄██▄ $rst
  685. $bld$f1█▄█▀███▀█▄█ $f2███▀▀██▀▀███ $f3▄█▀██▀█▄ $f4█▄█▀███▀█▄█ $f5███▀▀██▀▀███ $f6▄█▀██▀█▄$rst
  686. $bld$f1▀█████████▀ $f2▀▀▀██▀▀██▀▀▀ $f3▀▀█▀▀█▀▀ $f4▀█████████▀ $f5▀▀▀██▀▀██▀▀▀ $f6▀▀█▀▀█▀▀$rst
  687. $bld$f1 ▄▀ ▀▄ $f2▄▄▀▀ ▀▀ ▀▀▄▄ $f3▄▀▄▀▀▄▀▄ $f4 ▄▀ ▀▄ $f5▄▄▀▀ ▀▀ ▀▀▄▄ $f6▄▀▄▀▀▄▀▄$rst
  688. $f7▌$rst
  689. $f7▌$rst
  690. $f7 ▄█▄ $rst
  691. $f7▄█████████▄$rst
  692. $f7▀▀▀▀▀▀▀▀▀▀▀$rst
  693. EOF
  694. }
  695. #/etc/lsb-release